##=========================================================##
##==Purpose: A function that computes the slope and      ==##     
##==         offset via matrix computation.              ==##
##==                                                     ==##
##==Prepared by Chuen Seng Tan/John Storey/Keyur Desai   ==##
##==email: chuentan@princeton.edu/jstorey@princeton.edu/ ==##
##==       kdesai@princeton.edu                          ==##
##=========================================================##

mtx.linfit <- function(dat,y,method){
    ##==Input:
    ##==  dat: matrix with rows corresponding to the genes and columns the samples (response variables)
    ##==  y: a vector with length the corresponding to the number of samples  (indepdent variable)
    ##==  method: "slope", "offset"
    ##==Output:
    ##==  A vector of length equals to the rows of dat
	
    n <- dim(dat)[2]
    m <- dim(dat)[1]
    p <- rep(0,m)
    one <- rep(1,n)
    Id <- diag(one)
    X <- cbind(one,y)
    XXi <- solve(t(X)%*%X)
    if(method  == "slope") {
		T <- (XXi%*%t(X)%*%t(dat))[2,]
	}
	if(method  == "offset") {
		T <- (XXi%*%t(X)%*%t(dat))[1,]
	}
	
    return(T);
}

